#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <assert.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <limits.h>
#include <errno.h>

#define BUFSIZE	(1024*1024*1024)

char buf[BUFSIZE];

int
main(int argc, char *argv[])
{
	int s1, s2;
	int ret;
	int fromlen;
	struct sockaddr_in *from = (void *)buf;

	if (argc != 2) exit(1);
	fromlen = INT_MAX;
	fromlen++;
	s1 = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
	assert(s1 != -1);
	from->sin_addr.s_addr = INADDR_ANY;
	from->sin_port = htons(atoi(argv[1]));
	from->sin_family = AF_INET;
	ret = bind(s1, (struct sockaddr *)from, sizeof(*from));
	assert(ret == 0);
	ret = listen(s1, 5);
	assert(ret == 0);
	s2 = accept(s1, (struct sockaddr *)from, &fromlen);
	write(1, from, BUFSIZE);
	exit(0);
}
